//  prop_auto.cpp
//
//	YV12 to YUY2 converter PropertyPages
//
//	Copyright (c) 2005  N099
//

#include <streams.h>     // DirectShow (includes windows.h)
#include <dvdmedia.h>
#include <commctrl.h>

#include "hwdeintuids.h"
#include "hwdeint.h"

#include "prop_auto.h"
#include "resource.h"

// -----------------------------------------

CUnknown * WINAPI CHWDeintProp_AUTO::CreateInstance(LPUNKNOWN punk, HRESULT *phr)
{
    CHWDeintProp_AUTO * pNewObject = new CHWDeintProp_AUTO(punk);
    if (pNewObject == NULL)
	{
        *phr = E_OUTOFMEMORY;
    }
    return pNewObject;
}


CHWDeintProp_AUTO::CHWDeintProp_AUTO(LPUNKNOWN pUnk) :
	CBasePropertyPage(NAME("HWDeintProp_AUTO"), pUnk, IDD_HWDeintProp_AUTO, IDS_HWDeintProp_AUTO)
	,m_pHWDeint(0)
{
	m_sse = is_sse_usable();
}

void CHWDeintProp_AUTO::SetDirty(void)
{
	m_bDirty = TRUE;
	if (m_pPageSite)
    {
		m_pPageSite->OnStatusChange(PROPPAGESTATUS_DIRTY);
    }
}

HRESULT CHWDeintProp_AUTO::OnConnect(IUnknown *pUnk)
{
	if (pUnk == NULL)
    {
        return E_POINTER;
    }
    ASSERT(m_pHWDeint == NULL);

	HRESULT hr;
	// pUnk ŃtB^̃JX^ C^[tFCX₢킹B
	hr = pUnk->QueryInterface(IID_IHWDeint, reinterpret_cast<void**>(&m_pHWDeint));
	if (SUCCEEDED(hr)) {
		hr = m_pHWDeint->get_cfg_auto(&m_ad_cfg);
		m_new_cfg = m_ad_cfg;
	}

    return hr;
}

HRESULT CHWDeintProp_AUTO::OnActivate(void)
{
    ASSERT(m_pHWDeint != NULL);

	//field order
	SendDlgItemMessage(m_Dlg, IDC_AD_FIELD, BM_SETCHECK, m_new_cfg.field, 0);
	SendDlgItemMessage(m_Dlg, IDC_AD_FLIP, BM_SETCHECK, m_new_cfg.field_flip, 0);
	EnableWindow(GetDlgItem(m_Dlg, IDC_AD_FLIP), m_new_cfg.field);

	//interlace
	SendDlgItemMessage(m_Dlg, IDC_AD_INTERLACE, BM_SETCHECK, m_new_cfg.interlace, 0);
	EnableWindow(GetDlgItem(m_Dlg, IDC_AD_INTERLACE), m_new_cfg.field);

	//set core
	SendDlgItemMessage(m_Dlg, IDC_AD_SLIDER_C, TBM_SETRANGE, 0,
		(LPARAM)MAKELONG(AD_MIN_CORE_TH, AD_MAX_CORE_TH));
	SendDlgItemMessage(m_Dlg, IDC_AD_SLIDER_C, TBM_SETPOS, 1, m_new_cfg.core);

	//ser percent
	SendDlgItemMessage(m_Dlg, IDC_AD_SLIDER_P, TBM_SETRANGE, 0,
		(LPARAM)MAKELONG(AD_MIN_PERCENT_TH, AD_MAX_PERCENT_TH));
	SendDlgItemMessage(m_Dlg, IDC_AD_SLIDER_P, TBM_SETPOS, 1, m_new_cfg.i_percent);

	//text boxes
	SetDlgItemInt(m_Dlg, IDC_AD_DUR, m_new_cfg.duration, TRUE);
	SetDlgItemInt(m_Dlg, IDC_AD_TERM, m_new_cfg.e_term, TRUE);

	//sse
	SendDlgItemMessage(m_Dlg, IDC_AD_SSE, BM_SETCHECK, m_new_cfg.sse, 0);
	EnableWindow(GetDlgItem(m_Dlg, IDC_AD_SSE), m_sse);
		
	//visualize
	SendDlgItemMessage(m_Dlg, IDC_AD_VIS, BM_SETCHECK, m_new_cfg.vis, 0);
	

	return S_OK;
}

BOOL CHWDeintProp_AUTO::OnReceiveMessage(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
	case WM_COMMAND:
		if(LOWORD(wParam) == IDC_AD_FIELD){
			m_new_cfg.field = !m_new_cfg.field;
			EnableWindow(GetDlgItem(m_Dlg, IDC_AD_INTERLACE), m_new_cfg.field);
			EnableWindow(GetDlgItem(m_Dlg, IDC_AD_FLIP), m_new_cfg.field);
			SetDirty();
			return (LRESULT) 1;
		}
		else if(LOWORD(wParam) == IDC_AD_FLIP){
			m_new_cfg.field_flip = !m_new_cfg.field_flip;
			SetDirty();
			return (LRESULT) 1;
		}
		else if(LOWORD(wParam) == IDC_AD_INTERLACE){
			m_new_cfg.interlace = !m_new_cfg.interlace;
			SetDirty();
			return (LRESULT) 1;
		}
		else if(LOWORD(wParam) == IDC_AD_SSE){
			m_new_cfg.sse = (!m_new_cfg.sse) & m_sse;
			SetDirty();
			return (LRESULT) 1;
		}
		else if(LOWORD(wParam) == IDC_AD_VIS){
			m_new_cfg.vis = !m_new_cfg.vis;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_AD_DUR){
			if(HIWORD(wParam) == EN_CHANGE)
			{
				BOOL translated;
				int  val;
				val = GetDlgItemInt(m_Dlg, IDC_AD_DUR, &translated, FALSE);
				if(translated && val>=0 && m_new_cfg.duration != val){
					m_new_cfg.duration = val;
					SetDirty();
					return (LRESULT) 1;
				}else{
					break;
				}
			}
		}
		else if (LOWORD(wParam) == IDC_AD_TERM){
			if(HIWORD(wParam) == EN_CHANGE)
			{
				BOOL translated;
				int  val;
				val = GetDlgItemInt(m_Dlg, IDC_AD_TERM, &translated, FALSE);
				if(translated && val>0 && m_new_cfg.e_term != val){
					m_new_cfg.e_term = val;
					SetDirty();
					return (LRESULT) 1;
				}else if(translated && val<=0){
					SetDirty();
					return (LRESULT) 1;
				}else{
					break;
				}
			}
		}
		else if(LOWORD(wParam) == IDC_AD_DETECT){
			m_pHWDeint->reset_autodetect();
			return (LRESULT) 1;
		}
		else if(LOWORD(wParam)==IDC_AD_RESET){
			m_new_cfg.core = AD_DEF_CORE;
			m_new_cfg.i_percent = AD_DEF_PERCENT;
			m_new_cfg.duration = AD_DEF_DURATION;
			m_new_cfg.e_term = AD_DEF_ETERM;
			m_new_cfg.field = 0;
			m_new_cfg.field_flip = 0;
			m_new_cfg.interlace = 0;
			m_new_cfg.sse = m_sse;
			m_new_cfg.vis = 0; 

			//field order
			SendDlgItemMessage(m_Dlg, IDC_AD_FIELD, BM_SETCHECK, m_new_cfg.field, 0);
			SendDlgItemMessage(m_Dlg, IDC_AD_FLIP, BM_SETCHECK, m_new_cfg.field_flip, 0);
			EnableWindow(GetDlgItem(m_Dlg, IDC_AD_FLIP), m_new_cfg.field);

			//interlace
			SendDlgItemMessage(m_Dlg, IDC_AD_INTERLACE, BM_SETCHECK, m_new_cfg.interlace, 0);
			EnableWindow(GetDlgItem(m_Dlg, IDC_AD_INTERLACE), m_new_cfg.field);

			//core
			SendDlgItemMessage(m_Dlg, IDC_AD_SLIDER_C, TBM_SETPOS, 1, m_new_cfg.core);
			m_pHWDeint->set_core_th(m_new_cfg.core);
			
			//percent
			SendDlgItemMessage(m_Dlg, IDC_AD_SLIDER_P, TBM_SETPOS, 1, m_new_cfg.i_percent);
			m_pHWDeint->set_ipercent_th(m_new_cfg.i_percent);

			//text boxes
			SetDlgItemInt(m_Dlg, IDC_AD_DUR, m_new_cfg.duration, TRUE);
			SetDlgItemInt(m_Dlg, IDC_AD_TERM, m_new_cfg.e_term, TRUE);

			//sse + visual
			SendDlgItemMessage(m_Dlg, IDC_AD_SSE, BM_SETCHECK, m_new_cfg.sse, 0);
			SendDlgItemMessage(m_Dlg, IDC_AD_VIS, BM_SETCHECK, m_new_cfg.vis, 0);

			SetDirty();
			return (LRESULT) 1;
		}
		break;
	case WM_HSCROLL:
		// [U[XC_𓮂B
		switch(LOWORD(wParam))
		{
		case TB_BOTTOM:
		case TB_LINEDOWN:
		case TB_PAGEDOWN:
		case SB_THUMBTRACK:
		case TB_PAGEUP:
		case TB_LINEUP:
		case TB_TOP:
			if((HWND)lParam == GetDlgItem(m_Dlg, IDC_AD_SLIDER_C)){
				m_new_cfg.core = SendDlgItemMessage(m_Dlg, IDC_AD_SLIDER_C, TBM_GETPOS, 0, 0);
				m_pHWDeint->set_core_th(m_new_cfg.core);
				SetDirty();
				return (LRESULT) 1;
			} else if((HWND)lParam == GetDlgItem(m_Dlg, IDC_AD_SLIDER_P)){
				m_new_cfg.i_percent = SendDlgItemMessage(m_Dlg, IDC_AD_SLIDER_P, TBM_GETPOS, 0, 0);
				m_pHWDeint->set_ipercent_th(m_new_cfg.i_percent);
				SetDirty();
				return (LRESULT) 1;
			}
			break;
		}
	}

	// eNXɃbZ[WB
    return CBasePropertyPage::OnReceiveMessage(hwnd,uMsg,wParam,lParam);
}

HRESULT CHWDeintProp_AUTO::OnApplyChanges(void)
{
	SetDlgItemInt(m_Dlg, IDC_AD_DUR, m_new_cfg.duration, TRUE);
	SetDlgItemInt(m_Dlg, IDC_AD_TERM, m_new_cfg.e_term, TRUE);

	m_ad_cfg = m_new_cfg;
	m_pHWDeint->set_cfg_auto(m_ad_cfg);
	return S_OK;
}

HRESULT CHWDeintProp_AUTO::OnDisconnect(void)
{
    if (m_pHWDeint)
    {
		m_pHWDeint->set_core_th(m_ad_cfg.core);
		m_pHWDeint->set_ipercent_th(m_new_cfg.i_percent);
		
		m_pHWDeint->Release();
		m_pHWDeint = NULL;
	}
	return S_OK;
}


